#include "GuiFileDialog.hpp"
#include <raylibs/raygui.h>
#include <raylibs/modules/gui_window_file_dialog.hpp>


Gui_WindowFileDialog::Gui_WindowFileDialog()
{
	fileDialogState = new GuiWindowFileDialogState(InitGuiWindowFileDialog(GetWorkingDirectory()));
	fileDialogState->windowBounds = { 10, 10, fileDialogState->windowBounds.height, fileDialogState->windowBounds.height };
}

bool Gui_WindowFileDialog::update()
{
	bool file_opened = false;
	if (fileDialogState->SelectFilePressed)
	{
		// Load image file (if supported extension)
		if (IsFileExtension(fileDialogState->fileNameText, ".lua"))
		{
			strcpy(fileNameToLoad, TextFormat("%s/%s", fileDialogState->dirPathText, fileDialogState->fileNameText));
			openedFile = fileNameToLoad;
			file_opened = true;
		}

		fileDialogState->SelectFilePressed = false;
	}
	return file_opened;
}

void Gui_WindowFileDialog::draw()
{
	// raygui: controls drawing
	//----------------------------------------------------------------------------------
	if (fileDialogState->windowActive) GuiLock();

	if (GuiButton({ 20, 20, 140, 30 }, GuiIconText(GuiIconName::ICON_FILE_OPEN, "Open Image"))) fileDialogState->windowActive = true;

	GuiUnlock();

	// GUI: Dialog Window
	//--------------------------------------------------------------------------------
	GuiWindowFileDialog(fileDialogState);
	//--------------------------------------------------------------------------------

}